#! /bin/sh
#***************************************
#*              start.sh               *
#***************************************
#2005-11-29 first edition
#author: hyphen
#Usage: sh -x start.sh
#CopyRigth: GPL
#System: RedFlag DC 4.1
#Application Server: RedFlag HA 4.1

#set -n
declare -a PROCS
PROCS[0]="ora_pmon"
PROCS[1]="ora_dbw"
PROCS[2]="ora_lgwr"
PROCS[3]="ora_ckpt"
PROCS[4]="ora_smon"
PROCS[5]="ora_reco"

#PROCS[2]="XXXX" #u can add new process

#Oracle source
ORACLE_USER="system"	# SQL username for monitor
ORACLE_PASSWD="oracle"	# SQL user passwd for monitor
ORACLE_OWNER="oracle"	# Oracle Owner
ORACLE_SID="orcl"	# Oracle SID
export ORACLE_USER
export ORACLE_PASSWD

#enabel or disable the checks
LISTENERCHECK=1
WRITEREADCHECK=1

#path
QUERY_PATH=/opt/redflag/hacluster/scripts/oracle/oraclemon
ERROR_LOG=/opt/redflag/hacluster/log/sqlplus_error
SYSTEM_LOG=/var/log/messages
script="`basename $0`"

#date_echo fuction
dated_echo()
{
    date_now=`date +'%b %d %H:%M:%S'`
    echo "${date_now} ${service} ${script}[$$]: $*" >> $ERROR_LOG
    echo "${date_now} ${service} ${script}[$$]: $*" >> $SYSTEM_LOG
}

#Qery Functions
run_lsn_check ()
{
  su - oracle -c "lsnrctl status;"
  return $?
}

#check Status of Oracle
runstatus ()
{
	result=`su - oracle -c "$QUERY_PATH/runstatus.sh ${ORACLE_USER} ${ORACLE_PASSWD}"`
	if [ $? -eq 0 ]; then
	  return `expr "${result}" : ".ERROR.*"`
	  else
	  return 1
	fi
}

#use sql script to check Status of Oracle
run_pl_sql_query ()
{
        result=`su - oracle -c "sqlplus ${ORACLE_USER}/${ORACLE_PASSWD} @$QUERY_PATH/runplsql.sql -S /NOLOG"`
        if [ $? -eq 0 ]; then
          return `expr "${result}" : ".*ERROR.*"`
          else
          return 1
        fi
}

#Main Script
while true; do
	        echo $PROCS
		for proc in "${PROCS[@]}"
		do
			echo $proc
			running=`ps -ef |grep $proc | grep -v grep`
			if [ "x" = "x$running" ]; then
			  dated_echo "$proc is not present now!" 
			  check=0 #0 is exit code

			#lsnr check
			  if [ ${LISTENERCHECK} -eq 1 ]; then
			    run_lsn_check
			    if [ $? -ne 0 ];then
			      dated_echo "lsnr check failed!"
			      exit 2  #break while loop
			    fi
			    check=1
			  fi
        
			#write&read check
			  if [ ${WRITEREADCHECK} -eq 1 ]; then
			    runstatus
			    if [ $? -eq 0 ]; then
			      run_pl_sql_query
			      if [ $? -ne 0 ]; then
			      dated_echo "Sqlplus write/read check failed"
			      exit 2  #break while loop
			      fi
			      check=2
			    else
			      dated_echo "Sqlplus connecting check failed of ${ORACLE_SID}"
			      exit 2  #break while loop
			    fi
			  fi
   	  
			  if [ ${check} -eq 0 ]; then
				exit 2  #break while loop
			  fi
			fi
		done
		sleep 10  #sleep for next while loop
done

#2005-12-02 modify exit code
#check=0,means something is wrong,but not to exit.
#exit means exit immediatly.
#so if you want to exit,when all errors have happened.you can replace "exit 2" with "check=0",except last code "exit 2".
